package me.parsell.glowstonewire.core;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;

import me.parsell.glowstonewire.GlowstoneWire;
import me.parsell.glowstonewire.mixin.BrewingRecipeRegistryInvoker;
import me.parsell.glowstonewire.mixin.FireworkStarRecipeAccessor;
import net.minecraft.item.Items;
import net.minecraft.potion.Potions;
import net.minecraft.recipe.Ingredient;

public class glowRecipes {
    public static JsonObject MODDED_TO_VANILLA;
    public static JsonObject VANILLA_TO_MODDED;

    public static void init(){
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.WATER, glowItems.GLOWSTONE_DUST, Potions.THICK);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.LEAPING, glowItems.GLOWSTONE_DUST, Potions.STRONG_LEAPING);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.SLOWNESS, glowItems.GLOWSTONE_DUST, Potions.STRONG_SLOWNESS);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.TURTLE_MASTER, glowItems.GLOWSTONE_DUST, Potions.STRONG_TURTLE_MASTER);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.SWIFTNESS, glowItems.GLOWSTONE_DUST, Potions.STRONG_SWIFTNESS);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.HEALING, glowItems.GLOWSTONE_DUST, Potions.STRONG_HEALING);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.HARMING, glowItems.GLOWSTONE_DUST, Potions.STRONG_HARMING);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.POISON, glowItems.GLOWSTONE_DUST, Potions.STRONG_POISON);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.REGENERATION, glowItems.GLOWSTONE_DUST, Potions.STRONG_REGENERATION);
        BrewingRecipeRegistryInvoker.registerPotionRecipe(Potions.STRENGTH, glowItems.GLOWSTONE_DUST, Potions.STRONG_STRENGTH);

        // Manually reset the glowstone compability, since i cant find a way to read and reset.
        FireworkStarRecipeAccessor.setFlickerModifier(Ingredient.ofItems(Items.GLOWSTONE_DUST, glowItems.GLOWSTONE_DUST));

        if(GlowstoneWire.CONFIG.addConversionRecipes) {
            // Base JsonObjects
            JsonObject cIngredientVanilla = new JsonObject();
            JsonObject CIngredientModded = new JsonObject();
            JsonArray cIngredientsList = new JsonArray();
    
            cIngredientVanilla.addProperty("item", "minecraft:glowstone_dust");
            CIngredientModded.addProperty("item", "glowstonewire:glowstone_dust");

            // FOR VANILLA TO MODDED
            VANILLA_TO_MODDED = new JsonObject();
            // Header, defining what type of crafting recipe it is
            VANILLA_TO_MODDED.addProperty("type", "minecraft:crafting_shapeless");
            // Adding the ingredients
            cIngredientsList.add(cIngredientVanilla);
            VANILLA_TO_MODDED.add("ingredients", cIngredientsList);
            // Adding the result
            VANILLA_TO_MODDED.add("result", CIngredientModded);

            // Clearing out the old array for new
            cIngredientsList = new JsonArray();
    
            // FOR MODDED TO VANILLA
            MODDED_TO_VANILLA = new JsonObject();
            // Define recipe type
            MODDED_TO_VANILLA.addProperty("type", "minecraft:crafting_shapeless");
            // Add ingredients
            cIngredientsList.add(CIngredientModded);
            MODDED_TO_VANILLA.add("ingredients", cIngredientsList);
            // Add result
            MODDED_TO_VANILLA.add("result", cIngredientVanilla);
        }
    }
}
